//-----------------------------------------------------------------------
//       The GSI Online Offline Object Oriented (Go4) Project
//         Experiment Data Processing at EE department, GSI
//-----------------------------------------------------------------------
// Copyright (C) 2000- GSI Helmholtzzentrum fr Schwerionenforschung GmbH
//                     Planckstr. 1, 64291 Darmstadt, Germany
// Contact:            http://go4.gsi.de
//-----------------------------------------------------------------------
// This software can be used under the license agreements as stated
// in Go4License.txt file which is part of the distribution.
//-----------------------------------------------------------------------

#include "TXXXAnalysis.h"

#include <stdlib.h>
#include "Riostream.h"

#include "Go4EventServer.h"
#include "TGo4StepFactory.h"
#include "TGo4AnalysisStep.h"
#include "TGo4Version.h"

//***********************************************************
TXXXAnalysis::TXXXAnalysis(){}

//***********************************************************
// this constructor is called by go4analysis executable
TXXXAnalysis::TXXXAnalysis(int argc, char** argv) : TGo4Analysis(argc, argv)
{
   cout << "**** Create TXXXAnalysis " << argv[0] << endl;

   if (!TGo4Version::CheckVersion(__GO4BUILDVERSION__)) {
      cout << "****  Go4 version mismatch" << endl;
      exit(-1);
   }

// More settings are done in macro setup.C

   gROOT->ProcessLine(".x setup.C()");
   if(argc > 1) {
     cout << "Load configuration from "<< argv[1]<<endl;
     LoadStatus(argv[1]);// config root file (as saved from GUI)
   }
   Print(); // print setup

   // Define custom passwords for analysis server
   DefineServerPasswords("XXXadmin", "XXXcontrol", "XXXview");

}

//***********************************************************
TXXXAnalysis::~TXXXAnalysis()
{
   cout << "**** TXXXAnalysis: Delete instance" << endl;
}

//-----------------------------------------------------------
Int_t TXXXAnalysis::UserPreLoop()
{
   // called after start analysis before first event
   cout << "**** TXXXAnalysis: PreLoop" << endl;
   Print(); // print setup
   return 0;
}
//-----------------------------------------------------------
Int_t TXXXAnalysis::UserPostLoop()
{
   // called after close analysis after last  event
   // all this is optional:
   cout << "**** TXXXAnalysis: PostLoop" << endl;
   return 0;
}

//-----------------------------------------------------------
Int_t TXXXAnalysis::UserEventFunc()
{
   // all this is optional:
   // This function is called once for each event after all steps.
   return 0;
}
