#include "TXXXMakeCal1.h"
#include "Riostream.h"
#include "TH1.h"
#include "TXXXParam.h"

#include "TXXXEventUnp1.h"
#include "TXXXEventCal1.h"

//***********************************************************
TXXXMakeCal1::TXXXMakeCal1() : TGo4EventProcessor("Proc")
{
  cout << "**** TXXXMakeCal1: Create instance " << endl;
}
//***********************************************************
TXXXMakeCal1::~TXXXMakeCal1()
{
  cout << "**** TXXXMakeCal1: Delete instance " << endl;
}
//***********************************************************
// this one is used in standard factory
TXXXMakeCal1::TXXXMakeCal1(const char* name) : TGo4EventProcessor(name)
{
  cout << "**** TXXXMakeCal1: Create instance " << name << endl;

  //// init user analysis objects:

// Create of parameters and histograms (check if restored from auto save file):
  fPar1  = (TXXXParam *) MakeParameter("Cal1/Par1","TXXXParam"); // class TXXXParam
  fHis1  = (TH1I *) MakeTH1('I',"Cal1/Cal1His1","Channel 1",1000,1,5000,"Channels");
}
//-----------------------------------------------------------
// event function
Bool_t TXXXMakeCal1::BuildEvent(TGo4EventElement * output)
{
  Int_t items,i;

  TXXXEventUnp1 * input  = dynamic_cast<TXXXEventUnp1*> (GetOutputEvent("Unpack1"));
  TXXXEventCal1 * target = dynamic_cast<TXXXEventCal1*> (output);
  memset(target->fCal11, 0, sizeof(target->fCal11));
  items = sizeof(target->fCal11)/sizeof(target->fCal11[0]);
  for(i = 0; i < items; i++)
    if(input->fUnp11[i])
      target->fCal11[i] = fPar1->fOffset+fPar1->fFactor * input->fUnp11[i];
  FillHistograms(target); // fill histograms from event
  target->SetValid(kTRUE);
  return kTRUE;
}

//-----------------------------------------------------------
// histogramming function
Bool_t TXXXMakeCal1::FillHistograms(TXXXEventCal1 * event)
{
  fHis1->Fill(event->fCal11[0]);                        
  return kTRUE;
}
//----------------------------END OF GO4 SOURCE FILE ---------------------
