#include "TXXXMakeCal2.h"
#include "Riostream.h"
#include "TH1.h"
#include "TXXXParam.h"

#include "TXXXEventUnp2.h"
#include "TXXXEventCal2.h"

//***********************************************************
TXXXMakeCal2::TXXXMakeCal2() : TGo4EventProcessor("Proc")
{
  cout << "**** TXXXMakeCal2: Create instance " << endl;
}
//***********************************************************
TXXXMakeCal2::~TXXXMakeCal2()
{
  cout << "**** TXXXMakeCal2: Delete instance " << endl;
}
//***********************************************************
// this one is used in standard factory
TXXXMakeCal2::TXXXMakeCal2(const char* name) : TGo4EventProcessor(name)
{
  cout << "**** TXXXMakeCal2: Create instance " << name << endl;

  //// init user analysis objects:

// Create of parameters and histograms (check if restored from auto save file):
  fPar1  = (TXXXParam *) MakeParameter("Cal2/Par2","TXXXParam"); // class TXXXParam
  fHis1  = (TH1I *) MakeTH1('I',"Cal2/Cal2His1","Channel 1",1000,1,5000,"Channels");
}
//-----------------------------------------------------------
// event function
Bool_t TXXXMakeCal2::BuildEvent(TGo4EventElement * output)
{
  Int_t items,i;

  TXXXEventUnp2 * input  = dynamic_cast<TXXXEventUnp2*> (GetOutputEvent("Unpack2"));
  TXXXEventCal2 * target = dynamic_cast<TXXXEventCal2*> (output);
  memset(target->fCal22, 0, sizeof(target->fCal22));
  items = sizeof(target->fCal22)/sizeof(target->fCal22[0]);
  for(i = 0; i < items; i++)
    if(input->fUnp22[i]) 
      target->fCal22[i] = fPar1->fOffset+fPar1->fFactor * input->fUnp22[i];
  FillHistograms(target); // fill histograms from event
  target->SetValid(kTRUE);
  return kTRUE;
}

//-----------------------------------------------------------
// histogramming function
Bool_t TXXXMakeCal2::FillHistograms(TXXXEventCal2 * event)
{
  fHis1->Fill(event->fCal22[0]);                        
  return kTRUE;
}
//----------------------------END OF GO4 SOURCE FILE ---------------------
