#include "TXXXMakeUnp1.h"
#include "Riostream.h"
#include "TH1.h"

#include "TXXXEventUnp1.h"

//***********************************************************
TXXXMakeUnp1::TXXXMakeUnp1() : TGo4EventProcessor("Proc")
{
  cout << "**** TXXXMakeUnp1: Create instance " << endl;
}
//***********************************************************
TXXXMakeUnp1::~TXXXMakeUnp1()
{
  cout << "**** TXXXMakeUnp1: Delete instance " << endl;
}
//***********************************************************
// this one is used in standard factory
TXXXMakeUnp1::TXXXMakeUnp1(const char* name) : TGo4EventProcessor(name)
{
  cout << "**** TXXXMakeUnp1: Create instance " << name << endl;
// Create of parameters and histograms (check if restored from auto save file):
  fHis1  = (TH1I *) MakeTH1('I',"Unp1/Unp1His1","Channel 1",1000,1,5000,"Channels");
}
//-----------------------------------------------------------
// event function
Bool_t TXXXMakeUnp1::BuildEvent(TGo4EventElement * output)
{
  Int_t lwords,i;
  Int_t *pdata;
  TGo4MbsSubEvent * rawsub;

  TGo4MbsEvent  * raw    = dynamic_cast<TGo4MbsEvent*>  (GetInputEvent());
  TXXXEventUnp1 * target = dynamic_cast<TXXXEventUnp1*> (output);
  memset(target->fUnp11, 0, sizeof(target->fUnp11));
  // Copy data from input event into local arrays
  raw->ResetIterator();  // prepare loop over sub-events
  while((rawsub = raw->NextSubEvent()) != 0) // loop over subevents
    {
      pdata  = rawsub->GetDataField(); // pointer to first data longword
      lwords = rawsub->GetIntLen();    // number of longwords
      if(lwords > 8) lwords=8;         // take only first 8 lwords
      if(rawsub->GetSubcrate() == 1)
	for(i = 0; i < lwords; i++) target->fUnp11[i] = (Float_t)*pdata++;
    } // while subevents

  target->SetValid(kTRUE);
  FillHistograms(target); // fill histograms from output event

  return kTRUE;
}

//-----------------------------------------------------------
// histogramming function
Bool_t TXXXMakeUnp1::FillHistograms(TXXXEventUnp1 * event)
{
  fHis1->Fill(event->fUnp11[0]);                        
  return kTRUE;
}
//----------------------------END OF GO4 SOURCE FILE ---------------------
